import { isReadAction, isWriteAction, } from "./actions";
export function isReadTarget(target) {
    return isReadAction(target.action);
}
export function isWriteTarget(target) {
    return isWriteAction(target.action);
}
export function buildWriteTargetPath(target) {
    const targetPath = [target.field, target.relationName, target.action];
    if (typeof target.index === "number") {
        targetPath.push(target.index.toString());
    }
    return targetPath;
}
export function buildReadTargetPath(target) {
    if (target.field) {
        return [target.field, target.relationName, target.action];
    }
    return [target.action, target.relationName];
}
export function buildTargetPath(target) {
    return isReadTarget(target)
        ? buildReadTargetPath(target)
        : buildWriteTargetPath(target);
}
