"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildTargetPath = exports.buildReadTargetPath = exports.buildWriteTargetPath = exports.isWriteTarget = exports.isReadTarget = void 0;
const actions_1 = require("./actions");
function isReadTarget(target) {
    return (0, actions_1.isReadAction)(target.action);
}
exports.isReadTarget = isReadTarget;
function isWriteTarget(target) {
    return (0, actions_1.isWriteAction)(target.action);
}
exports.isWriteTarget = isWriteTarget;
function buildWriteTargetPath(target) {
    const targetPath = [target.field, target.relationName, target.action];
    if (typeof target.index === "number") {
        targetPath.push(target.index.toString());
    }
    return targetPath;
}
exports.buildWriteTargetPath = buildWriteTargetPath;
function buildReadTargetPath(target) {
    if (target.field) {
        return [target.field, target.relationName, target.action];
    }
    return [target.action, target.relationName];
}
exports.buildReadTargetPath = buildReadTargetPath;
function buildTargetPath(target) {
    return isReadTarget(target)
        ? buildReadTargetPath(target)
        : buildWriteTargetPath(target);
}
exports.buildTargetPath = buildTargetPath;
